<template>
  <v-container fill-height fluid>
    <v-layout column>
      <v-flex>
        <v-layout fill-height>
          <v-flex xs6 ref="left-flex" class="mx-1">
            <v-card>
              <component
                :is="charts[this.visualisation.left.id].component"
                :data="data"
                :width="width"
                :height="height"
                :dark="dark"
                :selectedNodes="selectedNodes"
                :zoomSelectionNodes="zoomSelectionNodes"
                :isZoomed="isZoomed"
                :degree="degree"
                v-on:set-degree="setMaxDegree"
                ref="left-graph"
                v-if="allDataLoaded"
              />
            </v-card>
          </v-flex>
          <v-flex>
            <v-layout column class="fill-height justify-center">
              <help-dialog></help-dialog>

              <settings-dialog
                :typesCharts="charts"
                :typesReorderings="reorderings"
                :maxDegree="maxDegree"
              ></settings-dialog>

              <insights-dialog></insights-dialog>

              <v-tooltip bottom>
                <template v-slot:activator="{ on }">
                  <v-btn
                    fab
                    small
                    color="primary"
                    @click="clearNodes"
                    v-on="on"
                  >
                    <v-icon>mdi-select-off</v-icon>
                  </v-btn>
                </template>
                <span>Undo selection</span>
              </v-tooltip>

              <v-tooltip bottom>
                <template v-slot:activator="{ on }">
                  <v-btn fab small color="primary" @click="zoomIn" v-on="on">
                    <v-icon>mdi-magnify-plus-outline</v-icon>
                  </v-btn>
                </template>
                <span>Focus</span>
              </v-tooltip>

              <v-tooltip bottom>
                <template v-slot:activator="{ on }">
                  <v-btn fab small color="primary" @click="zoomOut" v-on="on">
                    <v-icon>mdi-magnify-minus-outline</v-icon>
                  </v-btn>
                </template>
                <span>Defocus</span>
              </v-tooltip>

              <v-tooltip bottom>
                <template v-slot:activator="{ on }">
                  <v-btn
                    fab
                    small
                    color="primary"
                    @click="navigateToUpload"
                    v-on="on"
                  >
                    <v-icon>navigate_before</v-icon>
                  </v-btn>
                </template>
                <span>Back to datasets</span>
              </v-tooltip>
            </v-layout>
          </v-flex>

          <v-flex xs6 ref="right-flex" class="mx-1">
            <v-card>
              <component
                :is="reorderings[this.visualisation.right.id].component"
                :data="data"
                :width="width"
                :height="height"
                :dark="dark"
                :selectedNodes="selectedNodes"
                :zoomSelectionNodes="zoomSelectionNodes"
                :isZoomed="isZoomed"
                ref="right-graph"
                v-if="allDataLoaded"
              />
            </v-card>
          </v-flex>
        </v-layout>
      </v-flex>
    </v-layout>
  </v-container>
</template>

<script>
import { mapState } from "vuex";
import { isEmpty } from "lodash";
import HelpDialog from "@/components/HelpDialog.vue";
import SettingsDialog from "@/components/SettingsDialog.vue";
import InsightsDialog from "@/components/InsightsDialog.vue";
import NetworkForce from "@/components/NetworkForce.vue";
import NetworkRadial from "@/components/NetworkRadial.vue";
import Matrix from "@/components/Matrix.vue";
import Hierarchy from "@/components/Hierarchy.vue";
import Cluster from "@/components/Cluster.vue";

export default {
  name: "app",
  components: {
    HelpDialog,
    SettingsDialog,
    InsightsDialog,
    NetworkForce,
    NetworkRadial,
    Matrix,
    Hierarchy,
    Cluster
  },

  data() {
    return {
      width: 0,
      height: 0,
      charts: [
        {
          component: NetworkForce,
          requirements: "graph",
          name: "Force Network"
        },
        {
          component: NetworkRadial,
          requirements: "graph",
          name: "Radial Network"
        },
        {
          component: Hierarchy,
          requirements: "hierarchy",
          name: "Tidy Tree"
        },
        {
          component: Cluster,
          requirements: "hierarchy",
          name: "Cluster Tree"
        }
      ],
      reorderings: [
        {
          component: Matrix,
          type: undefined,
          requirements: "matrix",
          name: "No ordering"
        },
        {
          component: Matrix,
          type: "alphabetical",
          requirements: "matrix",
          name: "Alphabetical"
        },
        {
          component: Matrix,
          type: "degree_true",
          requirements: "matrix",
          name: "Outdegree"
        },
        {
          component: Matrix,
          type: "degree_false",
          requirements: "matrix",
          name: "Indegree"
        },
        {
          component: Matrix,
          type: "edgeweight_true",
          requirements: "matrix",
          name: "Out Edge weight"
        },
        {
          component: Matrix,
          type: "edgeweight_false",
          requirements: "matrix",
          name: "In Edge weight"
        }
      ]
    };
  },

  computed: {
    ...mapState([
      "visualisation",
      "dark",
      "currentDataset",
      "selectedNodes",
      "zoomSelectionNodes",
      "isZoomed",
      "degree",
      "maxDegree"
    ]),
    data() {
      return this.currentDataset.data;
    },
    allDataLoaded() {
      const data = Object.keys(this.data);
      const reqs =
        data
          .map(d => isEmpty(this.currentDataset.data[d]))
          .filter(x => x === false).length > 1;

      return reqs;
    }
  },

  methods: {
    handleResize() {
      this.width = this.$refs["right-flex"].clientWidth;
      this.height = this.$refs["right-flex"].clientHeight - 8;
    },
    clearNodes() {
      this.$store.commit("clearSelectedNodes");
    },
    navigateToUpload() {
      this.$router.push("/upload");
    },
    setMaxDegree(degree) {
      this.$store.commit("setMaxDegree", degree);
    },
    zoomIn() {
      if (this.selectedNodes != 0) {
        this.$store.commit("setZoomSelectionNodes", this.selectedNodes);
        this.$store.commit("clearSelectedNodes");
        this.$store.commit("setZoomed");
      }
    },
    zoomOut() {
      this.$store.commit("setZoomSelectionNodes", []);
      this.$store.commit("clearSelectedNodes");
      this.$store.commit("setZoomed");
    }
  },

  created() {
    this.$store.dispatch("getData");
  },

  mounted() {
    window.addEventListener("resize", this.handleResize);
    this.handleResize();
  },

  beforeDestroy() {
    window.removeEventListener("resize", this.handleResize);
  }
};
</script>
